mod panel;
mod x11;

use chan;
use chan_signal;

use std::thread;

pub fn ui_main(signal: chan::Receiver<chan_signal::Signal>) -> i32 {
    if let Some(conn) = x11::Connection::new() {

        let panel = panel::Panel::new(&conn);
        panel.create();

        let (tx, rx) = chan::sync(0);
        {
            let conn = conn.clone_connection();
            thread::spawn(move || {
                loop {
                    match conn.wait_for_event() {
                        Some(event) => { tx.send(event); },
                        None => { break; }
                    }
                }
            });
        }

        loop {
            chan_select!(
                rx.recv() -> event => {
                    if panel.handle_event(event.unwrap()) {
                        break;
                    }
                },
                signal.recv() => {
                    panel.finish();
                }
            );
        }
    }
    0
}
