use xcb;
use ui::x11;

pub struct Panel<'a> {
    conn: &'a x11::Connection,
    window: xcb::Window
}

impl<'a> Panel<'a> {
    pub fn new(conn: &x11::Connection) -> Panel {
        Panel {
            conn: conn,
            window: conn.generate_id()
        }
    }

    pub fn create(&self) {
        let screen = self.conn.default_screen();

        xcb::create_window(
            self.conn,
            xcb::COPY_FROM_PARENT as u8,
            self.window,
            screen.root,
            0, 0,
            screen.width, 20,
            0,
            xcb::WINDOW_CLASS_INPUT_OUTPUT as u16,
            xcb::COPY_FROM_PARENT,
            &[
                (xcb::CW_BACK_PIXEL, 0xFF000000),
                (xcb::CW_EVENT_MASK, xcb::EVENT_MASK_PROPERTY_CHANGE)
            ]
        );
        xcb::map_window(self.conn, self.window);
        self.conn.flush();
    }

    pub fn handle_event(&self, _event: xcb::GenericEvent) -> bool {
        false
    }

    pub fn finish(&self) {}
}
